// --------------- xor -----------------


#include "m_pd.h"

static t_class *xor_class;

typedef struct xor
{
    t_object x_obj;
    t_float x_f1;
    t_float x_f2;
} t_xor;


void xor_bang(t_xor *x)
{
    outlet_float(x->x_obj.ob_outlet, ((int)(x->x_f1)) ^ (int)(x->x_f2));
}

void xor_float(t_xor *x, t_float f)
{
    outlet_float(x->x_obj.ob_outlet, ((int)(x->x_f1 = f)) ^ (int)(x->x_f2));
}

void *xor_new(t_floatarg f)
{
    t_xor *x = (t_xor *)pd_new(xor_class);
    outlet_new(&x->x_obj, &s_float);
    floatinlet_new(&x->x_obj, &x->x_f2);
    x->x_f1 = 0;
    x->x_f2 = f;
    return (x);
}


void xor_setup(void)
{    
    xor_class = class_new(gensym("xor"), (t_newmethod)xor_new, 0,
    	sizeof(t_xor), 0, A_DEFFLOAT, 0);
    xor_class = class_new(gensym("^"), (t_newmethod)xor_new, 0,
    	sizeof(t_xor), 0, A_DEFFLOAT, 0);    	
    class_addbang(xor_class, xor_bang);
    class_addfloat(xor_class, (t_method)xor_float);  
}